## twin 0.4.0

=== clients/Makefile ===
#
# Makefile for various libTw clients
#
TOPDIR=..
SUBDIRS=mapscrn

-include $(TOPDIR)/makeautoconf

OBJS_twattach=attach.o
OBJS_twcat=cat.o
OBJS_twclip=clip.o
OBJS_twevent=event.o
OBJS_twdialog=dialog.o
OBJS_twdm=dm.o
OBJS_twfindtwin=findtwin.o
OBJS_twlsobj=lsobj.o
OBJS_twsendmsg=sendmsg.o
OBJS_twsetroot=setroot.o
OBJS_twsysmon=sysmon.o
OBJS_twterm=pty.o tterm.o
OBJS_twthreadtest=threadtest.o
OBJS_ttest=tt_test.o

CC_FLAGS_threadtest.o+=-D_REENTRANT

#
# LD_FLAGS+=$(LIBTW)
# use fine-grained libs instead:
#
LD_FLAGS_twattach+=$(LIBTW)
LD_FLAGS_twcat+=$(LIBTW)
LD_FLAGS_twclip+=$(LIBTW)
LD_FLAGS_twevent+=$(LIBTW)
LD_FLAGS_twdialog+=$(LIBTW)
LD_FLAGS_twdm+=$(LIBTW)
LD_FLAGS_twfindtwin+=$(LIBTW)
LD_FLAGS_twlsobj+=$(LIBTW)
LD_FLAGS_twsendmsg+=$(LIBTW)
LD_FLAGS_twsetroot+=$(LIBTW)
LD_FLAGS_twsysmon+=$(LIBTW)
LD_FLAGS_twterm+=$(LIBTW)
LD_FLAGS_twthreadtest+=$(LIBTW) $(LD_LIBPTHREAD)
LD_FLAGS_ttest+=$(LIBTT)

BINS=twattach twcat twclip twdialog twevent twfindtwin twlsobj twsendmsg twsetroot twsysmon twterm

#BINS+=ttest

all: everything

-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

ifneq ($(LD_LIBCRYPT),no)
 BINS+=twdm
 ifneq ($(LD_LIBCRYPT),)
   LD_FLAGS_twdm+=$(LD_LIBCRYPT)
 endif
endif

ifneq ($(bindir),)
  CC_FLAGS_dm.o=-DBINDIR=\"$(bindir)\"
endif
 
ifneq ($(CONF_SOCKET),n)
  ifeq ($(CONF_SOCKET_PTHREADS),y)
    BINS+=twthreadtest
  endif
  everything: $(BINS) twdetach subdirs
else
  everything:
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Support remote socket connections\"," ; \
	 $(ECHO) "so the remote clients will NOT be compiled!" ; \
	 $(ECHO)
endif


#
# include the do-everything file.
# Must correctly set all BINS, MODBINS, ARLIBS, CC_FLAGS* and LD_FLAGS* before including this!
#
include $(TOPDIR)/makerules



twdetach: twattach
	$(LN) $< $@

install:
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) $(BINS) $(DESTDIR)$(bindir)
	$(LN) twattach $(DESTDIR)$(bindir)/twdetach

clean:
	rm -f .*.flags .*.link gmon.out core *.o $(BINS)

=== contrib/Makefile ===
#
# Makefile for various contributed libTw clients
#

#
# list of subdirectories to build
#
SUBDIRS=

# add your binary to this list
#
BINS=twbiff

# place the object files for your binary here: you must add a line
# OBJS_<your binary>=<list of object files>
#
OBJS_twbiff=biff.o


#
# --------------- no user-serviceable parts below this line ----------------
#
TOPDIR=..

LD_FLAGS+=-L$(TOPDIR)/lib -lTw

all: everything


-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

include $(TOPDIR)/makerules


ifneq ($(CONF_SOCKET),n)
  everything: $(BINS)
else
  everything:
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Support remote socket connections\"," ; \
	 $(ECHO) "so the clients will NOT be compiled!" ; \
	 $(ECHO)
endif


#
# include the do-everything file.
# Must correctly set all CC_FLAGS* and LD_FLAGS* before including this!
#
include $(TOPDIR)/makerules


install:
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) $(BINS) $(DESTDIR)$(bindir)

clean:
	rm -f .*.flags .*.link gmon.out core $(OBJS) $(BINS)

=== docs/Makefile ===
#
# Makefile for docs/
#
#

TOPDIR=..
SUBDIRS=

ALLOBJS=
BINS=
MODBINS=

DOCS=Configure Tutorial libTw.txt twin.1
TOPDOCS=README BUGS INSTALL README.porting COPYING twin-current.lsm \
	COPYING.LIB Changelog.txt 

#
# target
#
all: 

#
# read configuration
#
-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

#
# include the do-everything file.
# Must correctly set all CC_FLAGS* and LD_FLAGS* before including this!
#
#
include $(TOPDIR)/makerules


#
# All done. Now just set a few special targets
#

clean:

install:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man1
	$(INSTALL-TXT) twin.1 $(DESTDIR)$(mandir)/man1
	$(INSTALL) -d $(DESTDIR)$(datadir)/twin/docs
	$(INSTALL-TXT) $(DOCS) $(DESTDIR)$(datadir)/twin/docs
	cd $(TOPDIR) && $(INSTALL-TXT) $(TOPDOCS) $(DESTDIR)$(datadir)/twin

=== include/Makefile ===
#
# Makefile for the various includes
#
TOPDIR=..
SUBDIRS=

all: autogen

autogen: socklistm4.h

include $(TOPDIR)/makerules

=== libs/Makefile ===
#
# Makefile for the various libraries
#
TOPDIR=..
SUBDIRS=$(filter-out libTT, $(wildcard lib*))

all: subdirs

# library dependencies:
dir-libTw: dir-libTutf

dir-libTT: dir-libTw



include $(TOPDIR)/makerules

=== server/Makefile ===
#
# Makefile for twin - Text mode WINdow manager
#
#

TOPDIR=..
SUBDIRS=HW

-include $(TOPDIR)/makeautoconf

BASEOBJS=data.o builtin.o methods.o util.o draw.o extensions.o main.o \
         missing.o hw_multi.o printk.o resize.o scroller.o remote.o alloc.o
HWOBJS=hw.o HW/hw.a
DLOBJS=dl.o
WMOBJS=wm.o rcrun.o rcopt.o
RCPARSEOBJS=rcparse_tab.o rcparse_lex.o shm.o
TERMOBJS=pty.o tty.o tterm.o 
SOCKETOBJS=socket.o md5.o
WRAPOBJS=wrapper.o
DISPLAYOBJS=display.o
ALLOBJS:=$(BASEOBJS) $(HWOBJS) $(DLOBJS) $(WMOBJS) $(TERMOBJS) \
	 $(SOCKETOBJS) $(WRAPOBJS) $(DISPLAYOBJS) $(RCPARSEOBJS)

OBJS_twin_real:=$(BASEOBJS) $(HWOBJS)
OBJS_wm.so:=$(WMOBJS)
OBJS_rcparse.so:=$(RCPARSEOBJS)
OBJS_term.so:=$(TERMOBJS)
OBJS_socket.so:=$(SOCKETOBJS)
OBJS_twin_wrapper:=$(WRAPOBJS)
OBJS_twdisplay:=$(DISPLAYOBJS) alloc.o missing.o $(HWOBJS)

BINS=twin_real twin_wrapper
MODBINS=

LD_FLAGS_wm.so=-lc -shared
LD_FLAGS_rcparse.so=-lc -shared
LD_FLAGS_rcrun.so=-lc -shared
LD_FLAGS_term.so=-lc -shared
LD_FLAGS_socket.so=-lc -shared
LD_FLAGS_twdisplay=$(LIBTW)

#
# tweak flags based on current paths configuration
#
ifneq ($(libdir),)
  CC_FLAGS_data.o=-DLIBDIR=\"$(libdir)\"
  CC_FLAGS_display.o=-DLIBDIR=\"$(libdir)\"
endif
ifneq ($(bindir),)
  CC_FLAGS_wrapper.o=-DBINDIR=\"$(bindir)\"
endif


#
# OS-specific stuff
#
ifneq ($(GNULD),)
  LD_FLAGS_rdynamic:=-rdynamic
endif

#
# target
#
all: bins modules twin handy

#
# read configuration
#
-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

#
# set variables according conf.current
# and group together all *.o objects needed by each binary
#
ifeq ($(CONF__MODULES),y)
  LD_FLAGS_twin_real+=$(LD_LIBDL) $(LD_FLAGS_rdynamic)
  OBJS_twin_real+=$(DLOBJS)
  LD_FLAGS_twdisplay+=$(LD_LIBDL) $(LD_FLAGS_rdynamic)
else
  EXCL_OBJS+=$(DLOBJS)
endif

ifeq ($(CONF__ALLOC),y)
  CC_FLAGS+=-DCONF__ALLOC
endif

ifeq ($(CONF_WM),y)
  OBJS_twin_real+=$(WMOBJS)
else
  ifeq ($(CONF_WM),m)
    MODBINS+=wm.so
  else
    EXCL_OBJS+=$(WMOBJS)
  endif
endif

ifeq ($(CONF_WM_RC),y)
  OBJS_twin_real+=$(RCPARSEOBJS)
else
  ifeq ($(CONF_WM_RC),m)
    MODBINS+=rcparse.so
  else
    EXCL_OBJS+=$(RCPARSEOBJS)
  endif
endif

 
ifeq ($(CONF_TERM),y)
  OBJS_twin_real+=$(TERMOBJS)
else
  ifeq ($(CONF_TERM),m)
    MODBINS+=term.so
  else
    EXCL_OBJS+=$(TERMOBJS)
  endif
endif

ifeq ($(CONF_SOCKET),n)
  EXCL_OBJS+=$(SOCKETOBJS)
else
  LD_FLAGS_twin_real+=$(LD_LIBSOCKET)
  LD_FLAGS_twdisplay+=$(LD_LIBSOCKET)
  ifeq ($(CONF_SOCKET),y)
    OBJS_twin_real+=$(SOCKETOBJS)
  else
    MODBINS+=socket.so
  endif
  ifeq ($(CONF_SOCKET_GZ),y)
    ifeq ($(CONF_SOCKET),y)
      LD_FLAGS_twin_real+=-lz
     else
      LD_FLAGS_socket.so+=-lz
    endif
  endif
endif

#
# suid root / sgid tty stuff
#
ifneq ($(CONF_TERM),n)
  ifeq ($(CONF_TERM_DEVPTS),y)
    PRIV=tty
  else
    PRIV=root
  endif
else
  ifeq ($(CONF_MODULES),y)
    PRIV=root
  else
    PRIV=
  endif
endif

ifeq ($(PRIV),root)
  SETPRIV=chmod u+s $(DESTDIR)$(bindir)/twin_real
  SETPRIV_COMM=(i.e. suid root privileges)
else
  SETPRIV=chown .tty $(DESTDIR)$(bindir)/twin_real && chmod g+s $(DESTDIR)$(bindir)/twin_real
  SETPRIV_COMM=(i.e. sgid tty privileges)
endif

#
# the final link nightmare...
#
ifeq ($(CONF__UNICODE),y)
  LD_FLAGS_twin_real+=$(LIBTUTF)
  LD_FLAGS_twdisplay+=$(LIBTUTF)
endif

ifeq ($(CONF_HW_TTY),y)
  ifeq ($(CONF_HW_TTY_LINUX),y)
    LD_FLAGS_twin_real+=-lgpm
    LD_FLAGS_twdisplay+=-lgpm
  endif
  ifeq ($(CONF_HW_TTY_TERMCAP),y)
    ifeq ($(CONF_HW_TTY_LINUX),y)
      ifeq ($(LD_LIBTERMCAP_IN_LIBGPM),)
        LD_FLAGS_twin_real+=$(LD_LIBTERMCAP)
        LD_FLAGS_twdisplay+=$(LD_LIBTERMCAP)
      # else necessary libs are already pulled in with -lgpm above
      endif
    else
      LD_FLAGS_twin_real+=$(LD_LIBTERMCAP)
      LD_FLAGS_twdisplay+=$(LD_LIBTERMCAP)
    endif
  endif
endif
ifeq ($(CONF_HW_X11),y)
  LD_FLAGS_twin_real+=-L/usr/X11R6/lib -lX11
  LD_FLAGS_twdisplay+=-L/usr/X11R6/lib -lX11
endif
ifeq ($(CONF_HW_GGI),y)
  LD_FLAGS_twin_real+=-lggi
  LD_FLAGS_twdisplay+=-lggi
endif
ifneq ($(CONF_SOCKET),n)
  ifneq ($(CONF_HW_DISPLAY),n)
    BINS+=twdisplay
  endif
  ifeq ($(CONF_HW_TWIN),y)
    LD_FLAGS_twin_real+=$(LIBTW)
  endif
endif


#
# common rules
#
include $(TOPDIR)/makerules


bins: $(BINS)

modules: $(MODBINS)


#
# All done. Now just set a few special targets
#

twin: twin_wrapper
	$(LN) $< $@

# the '@:' dummy command is to force relinking after HW/hw.a is rebuilt
HW/hw.a: dir-HW
	@:

autogen: rcparse_tab.c rcparse_tab.h rcparse_lex.c socket1m4.h socket2m4.h socket3m4.h

handy: .twinrc

.twinrc:
	$(LN) ../system.twinrc .twinrc

rcparse_tab.c rcparse_tab.h: rcparse.y
	bison -d --no-lines -o $@ $<

rcparse_lex.c: rcparse.l
	flex -L -B -o$@ $<

socketmacros%.h: m4/macros%.m4 $(TOPDIR)/include/sockproto.h
	m4 -I$(TOPDIR)/include $< > $@

symbolsdep: all
	for i in *.o; do nm $$i | grep 'U ' | cut -dU -f2- > $${i%%.o}.u; done; :
	for i in *.o; do nm $$i | grep 'B \| C \| D \| T ' > $${i%%.o}.d; done; :
	for i in *.u; do $(ECHO); $(ECHO) $$i; for j in `cat $$i`; do \
	grep -e " $${j}\$$" *.d; done | sort; done > $@; :

clean:
	rm -f .*.flags .*.link .*.arlib gmon.out core log twin \
	      twin_real twin_wrapper twdisplay *.so \
	      *.o \
	      rcparse.output y.tab.c lex.yy.c \
	      *.u *.d


install:
	$(INSTALL) -d $(DESTDIR)$(bindir) $(DESTDIR)/$(libdir)/twin/modules
	$(INSTALL) $(BINS) twstart $(DESTDIR)$(bindir)
	$(LN) twin_wrapper $(DESTDIR)$(bindir)/twin
	if [ "$(MODBINS)" ]; then \
	  $(INSTALL) $(MODBINS) $(DESTDIR)$(libdir)/twin/modules; \
	fi
	@if [ "$(SETPRIV)" ]; then \
	  $(ECHO) [1m ; \
	  $(ECHO) Twin may need special privileges for the terminal emulator to work. ; \
	  $(ECHO) More exactly, the following command could be necessary: ; \
	  $(ECHO) "   $(SETPRIV)" ; \
	  $(ECHO) "$(SETPRIV_COMM)" ; \
	  $(ECHO) Since twin has not been extensively tested against vulnerabilities, ; \
	  $(ECHO) you will grant special privileges to twin AT YOUR OWN RISK. ; \
	  $(ECHO) [0m ; \
	fi

=== clients/mapscrn/Makefile ===
#
# Makefile for twmapscrn libTw client
#
TOPDIR=../..
SUBDIRS=

CC_FLAGS+=-DDATADIR=\"/usr/lib/kbd\"
CC_FLAGS_mapscrn.o+=-DMAIN

LD_FLAGS+=$(LIBTW)

OBJS_twmapscrn=mapscrn.o findfile.o utf8.o xmalloc.o getfd.o kdmapop.o
BINS=twmapscrn


all: $(BINS)

-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

#
# include the do-everything file.
# Must correctly set all CFLAGS* and LDFLAGS* before including this!
#
include $(TOPDIR)/makerules


install:
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) $(BINS) $(DESTDIR)$(bindir)

clean:
	rm -f .*.flags .*.link gmon.out core $(OBJS) $(BINS)

=== libs/libTT/Makefile ===
#
# Makefile for libTT, `The Text Toolkit' library sitting on top of libTw
#
TOPDIR=../..
SUBDIRS=

all: everything

VERSION=0.0.3
SO_VER=0

BINS=libTT.so.$(VERSION)
ARLIBS=libTT.a


OBJS_libTT.so.$(VERSION)=libTT.o missing.o
OBJS_libTT.a=libTT_u.o missing_u.o

CC_FLAGS_libTT.o+=-fPIC -D_REENTRANT
CC_FLAGS_missing.o+=-fPIC -D_REENTRANT
CC_FLAGS_libTT_u.o+=-D_REENTRANT
CC_FLAGS_missing_u.o+=-D_REENTRANT

LD_FLAGS_libTT.so.$(VERSION)=$(LIBTW) $(LD_FLAGS_SOLIB)libTT.so.$(SO_VER)

-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

ifneq ($(CONF_SOCKET),n)
  everything: lib
  install: install-real
  ifeq ($(CONF__UNICODE),y)
    LD_FLAGS_libTT.so.$(VERSION)+=$(LIBTUTF)
  endif
else
  everything: warn
  install: warn
  warn:
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Support remote socket connections\"," ; \
	 $(ECHO) "so the library libTT.so will NOT be compiled!" ; \
	 $(ECHO)
endif

#
# include the do-everything file.
# Must correctly set all CC_FLAGS* and LD_FLAGS* before including this!
#
include $(TOPDIR)/makerules


#
# handy targets
#
ifeq ($(CONF__SHLIBS),y)
  lib: $(ARLIBS) $(BINS) links
else
  lib: $(ARLIBS)
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Enable shared libraries (ELF)\"," ; \
	 $(ECHO) "so only the static library libTT.a will be compiled!" ; \
	 $(ECHO)
endif

autogen: methodsm4.h TTm4.h

methodsm4.h: methods_base.h

missing.c missing_u.c:
	$(LN) $(TOPDIR)/server/missing.c missing.c && \
	$(LN) $(TOPDIR)/server/missing.c missing_u.c

links: libTT.so.$(SO_VER) libTT.so

libTT.so.$(SO_VER):
	$(LN) libTT.so.$(VERSION) libTT.so.$(SO_VER)

libTT.so:
	$(LN) libTT.so.$(SO_VER) libTT.so

libTT_u.c:
	$(LN) libTT.c libTT_u.c

install-headers:
	$(INSTALL) -d $(DESTDIR)$(includedir)/TT && \
	$(INSTALL-TXT) $(TOPDIR)/include/TT/*.h $(DESTDIR)$(includedir)/TT && \
	$(LN) TT/TT++.h $(DESTDIR)$(includedir)/libTT++.h && \
	$(LN) TT/TT.h $(DESTDIR)$(includedir)/libTT.h

install-real: install-headers
	$(INSTALL) -d $(DESTDIR)$(libdir) && \
	$(INSTALL-TXT) $(ARLIBS) $(DESTDIR)$(libdir) && \
	if [ -f libTT.so.$(VERSION) ]; then \
		$(INSTALL) libTT.so.$(VERSION) $(DESTDIR)$(libdir) && \
		$(LN) libTT.so.$(VERSION) $(DESTDIR)$(libdir)/libTT.so.$(SO_VER) && \
		$(LN) libTT.so.$(SO_VER)  $(DESTDIR)$(libdir)/libTT.so; \
	fi
	
clean:
	rm -f .*.flags .*.link .*.arlib libTT.so* libTT.a $(_ALLOBJS)

=== libs/libTutf/Makefile ===
#
# Makefile for libTutf, the UTF-16 charset conversion library
#
TOPDIR=../..
SUBDIRS=

all: everything

VERSION=0.0.3
SO_VER=0

BINS=libTutf.so.$(VERSION)
ARLIBS=libTutf.a

OBJS_libTutf.so.$(VERSION)=libTutf.o
OBJS_libTutf.a=libTutf_u.o

CC_FLAGS_libTutf.o+=-fPIC -D_REENTRANT
CC_FLAGS_libTutf_u.o+=-D_REENTRANT

LD_FLAGS_libTutf.so.$(VERSION)=$(LD_FLAGS_SOLIB)libTutf.so.$(SO_VER)

-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend


ifneq ($(CONF_SOCKET),n)
  ifeq ($(CONF__UNICODE),y)
    everything: lib
    install: install-real
  else
    everything install:
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Build all code with Unicode support\"," ; \
	 $(ECHO) "so the library libTutf will NOT be compiled!" ; \
	 $(ECHO)
  endif
else
  everything install:
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Support remote socket connections\"," ; \
	 $(ECHO) "so the library libTw.so will NOT be compiled!" ; \
	 $(ECHO)
endif

#
# handy targets
#


ifeq ($(CONF__SHLIBS),y)
  lib: $(ARLIBS) $(BINS) links
else
  lib: $(ARLIBS)
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Enable shared libraries (ELF)\"," ; \
	 $(ECHO) "so only the static library libTutf.a will be compiled!" ; \
	 $(ECHO)
endif


#
# include the do-everything file.
# Must correctly set all CC_FLAGS* and LD_FLAGS* before including this!
#
#
include $(TOPDIR)/makerules



links: libTutf.so.$(SO_VER) libTutf.so

libTutf.so.$(SO_VER):
	$(LN) libTutf.so.$(VERSION) libTutf.so.$(SO_VER)

libTutf.so:
	$(LN) libTutf.so.$(SO_VER) libTutf.so

libTutf_u.c:
	$(LN) libTutf.c libTutf_u.c

install-headers:
	$(INSTALL) -d $(DESTDIR)$(includedir)/Tutf && \
	$(INSTALL-TXT) $(TOPDIR)/include/Tutf/*.h $(DESTDIR)$(includedir)/Tutf

install-real: install-headers
	$(INSTALL) -d $(DESTDIR)$(libdir) && \
	$(INSTALL-TXT) $(ARLIBS) $(DESTDIR)$(libdir) && \
	if [ -f libTutf.so.$(VERSION) ]; then \
		$(INSTALL) libTutf.so.$(VERSION) $(DESTDIR)$(libdir) && \
		$(LN) libTutf.so.$(VERSION) $(DESTDIR)$(libdir)/libTutf.so.$(SO_VER) && \
		$(LN) libTutf.so.$(SO_VER)  $(DESTDIR)$(libdir)/libTutf.so; \
	fi
	
clean:
	rm -f .*.flags .*.link .*.arlib libTutf.so* libTutf.a $(_ALLOBJS)

=== libs/libTw/Makefile ===
#
# Makefile for libTw, the library that talks to Twin
#
TOPDIR=../..
SUBDIRS=

-include $(TOPDIR)/makeautoconf

LD_FLAGS+=$(LD_LIBSOCKET)

all: everything

VERSION=3.0.3
SO_VER=3

BINS=libTw.so.$(VERSION)
ARLIBS=libTw.a



OBJS_libTw.so.$(VERSION)=libTw.o avl.o md5.o missing.o
OBJS_libTw.a=libTw_u.o avl_u.o md5_u.o missing_u.o

CC_FLAGS_libTw.o+=-fPIC -D_REENTRANT
CC_FLAGS_avl.o+=-fPIC -D_REENTRANT
CC_FLAGS_md5.o+=-fPIC -D_REENTRANT
CC_FLAGS_missing.o+=-fPIC -D_REENTRANT
CC_FLAGS_libTw_u.o+=-D_REENTRANT
CC_FLAGS_avl_u.o+=-D_REENTRANT
CC_FLAGS_md5_u.o+=-D_REENTRANT
CC_FLAGS_missing_u.o+=-D_REENTRANT

LD_FLAGS_libTw.so.$(VERSION)=$(LD_FLAGS_SOLIB)libTw.so.$(SO_VER)

-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

ifneq ($(CONF_SOCKET),n)
  # do not link against libpthread: let client programs specify it explicitly
  # if they want to use threads, so that if they don't,
  # fallback, do-nothing functions will be picked from libc (if they exist)
  # avoiding overhead.
  #
  ifeq ($(CONF_SOCKET_PTHREADS),y)
    LD_FLAGS_libTw.so.$(VERSION)+=$(LD_LIBPTHREAD_WEAK)
  endif
  everything: lib
  install: install-real
  ifeq ($(CONF_SOCKET_GZ),y)
    LD_FLAGS_libTw.so.$(VERSION)+=-lz
  endif
else
  everything: warn
  install: warn
  warn:
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Support remote socket connections\"," ; \
	 $(ECHO) "so the library libTw.so will NOT be compiled!" ; \
	 $(ECHO)
endif


#
# include the do-everything file.
# Must correctly set all CC_FLAGS* and LD_FLAGS* before including this!
#
include $(TOPDIR)/makerules



#
# handy targets
#
ifeq ($(CONF__SHLIBS),y)
  lib: $(ARLIBS) $(BINS) links
else
  lib: $(ARLIBS)
	@$(ECHO) ; \
	 $(ECHO) "You disabled \"Enable shared libraries (ELF)\"," ; \
	 $(ECHO) "so only the static library libTw.a will be compiled!" ; \
	 $(ECHO)
endif

links: libTw.so.$(SO_VER) libTw.so

libTw.so.$(SO_VER):
	$(LN) libTw.so.$(VERSION) libTw.so.$(SO_VER)

libTw.so:
	$(LN) libTw.so.$(SO_VER) libTw.so

libTw_u.c avl_u.c md5.c md5_u.c missing.c missing_u.c:
	$(LN) libTw.c libTw_u.c && \
	$(LN) avl.c avl_u.c && \
	$(LN) $(TOPDIR)/server/md5.c md5.c && \
	$(LN) $(TOPDIR)/server/md5.c md5_u.c && \
	$(LN) $(TOPDIR)/server/missing.c missing.c && \
	$(LN) $(TOPDIR)/server/missing.c missing_u.c

autogen: paranoiam4.h libTw1m4.h libTw2m4.h

install-headers:
	$(INSTALL) -d $(DESTDIR)$(includedir)/Tw && \
	$(INSTALL-TXT) $(TOPDIR)/include/Tw/*.h $(DESTDIR)$(includedir)/Tw

install-real: install-headers
	$(INSTALL) -d $(DESTDIR)$(libdir) && \
	$(INSTALL-TXT) $(ARLIBS) $(DESTDIR)$(libdir) && \
	if [ -f libTw.so.$(VERSION) ]; then \
		$(INSTALL) libTw.so.$(VERSION) $(DESTDIR)$(libdir) && \
		$(LN) libTw.so.$(VERSION) $(DESTDIR)$(libdir)/libTw.so.$(SO_VER) && \
		$(LN) libTw.so.$(SO_VER)  $(DESTDIR)$(libdir)/libTw.so; \
	fi

clean:
	rm -f .*.flags .*.link .*.arlib libTw.so* libTw.a $(_ALLOBJS)

=== server/HW/Makefile ===
#
# Makefile for twin - Text mode WINdow manager
#
#

TOPDIR=../..
SUBDIRS=

-include $(TOPDIR)/makeautoconf

CC_FLAGS+=-I..

BASEOBJS=
TTYOBJS=hw_tty.o
X11OBJS=hw_X11.o
DISPLAYOBJS=hw_display.o
TWINOBJS=hw_twin.o
GGIOBJS=hw_ggi.o
ALLOBJS:=$(BASEOBJS) $(TTYOBJS) $(X11OBJS) $(DISPLAYOBJS) $(TWINOBJS) $(GGIOBJS)

OBJS_hw.a:=$(BASEOBJS)
OBJS_hw_tty.so=$(TTYOBJS)
OBJS_hw_X11.so=$(X11OBJS)
OBJS_hw_display.so=$(DISPLAYOBJS)
OBJS_hw_twin.so=$(TWINOBJS)
OBJS_hw_ggi.so=$(GGIOBJS)

BINS=
MODBINS=
ARLIBS=hw.a

CC_FLAGS_hw_X11.o+=$(CF_HEADERX11)

LD_FLAGS_hw_tty.so=-lc -shared
LD_FLAGS_hw_X11.so=-lc -shared $(LD_LIBX11)
LD_FLAGS_hw_display.so=-lc -shared
LD_FLAGS_hw_twin.so=-lc -shared $(LIBTW)
LD_FLAGS_hw_ggi.so=-lc -shared -lggi

#
# target
#
all: $(ARLIBS) modules

#
# read configuration
#
-include $(TOPDIR)/conf/conf.current
-include .modules
-include .depend

#
# set variables according conf.current
# and group together all *.o objects needed by each binary
#

ifeq ($(CONF__ALLOC),y)
  CC_FLAGS+=-DCONF__ALLOC
endif

#ifeq ($(CONF__UNICODE),y)
#  LD_FLAGS+=$(LIBTUTF)
#endif

ifeq ($(CONF_HW_TTY),y)
  OBJS_hw.a+=$(TTYOBJS)
else
  ifeq ($(CONF_HW_TTY),m)
    MODBINS+=hw_tty.so
    ifeq ($(CONF_HW_TTY_LINUX),y)
      LD_FLAGS_hw_tty.so+=-lgpm
    endif
    ifeq ($(CONF_HW_TTY_TERMCAP),y)
      CC_FLAGS_hw_tty.o+=-I/usr/include/ncurses
      ifeq ($(CONF_HW_TTY_LINUX),y)
        ifeq ($(LD_LIBTERMCAP_IN_LIBGPM),)
          LD_FLAGS_hw_tty.so+=$(LD_LIBTERMCAP)
	# else necessary libs are already pulled in with -lgpm above
	endif
      else
        LD_FLAGS_hw_tty.so+=$(LD_LIBTERMCAP)
      endif
    endif
  else
    EXCL_OBJS+=$(TTYOBJS)
  endif
endif

ifeq ($(CONF_HW_X11),y)
  OBJS_hw.a+=$(X11OBJS)
else
  ifeq ($(CONF_HW_X11),m)
  
    all: hw_X.so
    
    MODBINS+=hw_X11.so
    
  else
    EXCL_OBJS+=$(X11OBJS)
  endif
endif

ifneq ($(CONF_SOCKET),n)
  ifeq ($(CONF_HW_TWIN),y)
    OBJS_hw.a+=$(TWINOBJS)
  else
    ifeq ($(CONF_HW_TWIN),m)
      MODBINS+=hw_twin.so
    else
      EXCL_OBJS+=$(TWINOBJS)
    endif
  endif
  
  ifeq ($(CONF_HW_DISPLAY),y)
    OBJS_hw.a+=$(DISPLAYOBJS)
  else
    ifeq ($(CONF_HW_DISPLAY),m)
      MODBINS+=hw_display.so
    else
      EXCL_OBJS+=$(DISPLAYOBJS)
    endif
  endif
endif

ifeq ($(CONF_HW_GGI),y)
  OBJS_hw.a+=$(GGIOBJS)
else
  ifeq ($(CONF_HW_GGI),m)
    MODBINS+=hw_ggi.so
  else
    EXCL_OBJS+=$(GGIOBJS)
  endif
endif

#
# common rules
#
include $(TOPDIR)/makerules

#
# All done. Now just set a few special targets
#

modules: $(MODBINS)

hw_X.so: hw_X11.so
	$(LN) $< $@

clean:
	rm -f .*.flags .*.link .*.arlib hw.a hw_*.so $(ALLOBJS)

install:
	if [ "$(MODBINS)" ]; then \
	  $(INSTALL) -d $(DESTDIR)$(libdir)/twin/modules/HW; \
	  $(INSTALL) $(MODBINS) $(DESTDIR)$(libdir)/twin/modules/HW; \
	  $(LN) hw_X11.so $(DESTDIR)$(libdir)/twin/modules/HW/hw_X.so; \
	fi

## twin 0.5.1

=== Makefile ===



all:
	@echo "You should run './configure [options]'" ; \
	 echo "to configure twin for your system" ; \
	 false

build:
	B="build-on-`hostname`" ; \
	mkdir "$$B" 2>/dev/null ; \
	cd "$$B" && \
	$(MAKE) -f ../Makefile.sub TOP_SRCDIR="../"

install:
	B="build-on-`hostname`" ; \
	cd "$$B" && \
	$(MAKE) install

## twin 0.9.0

=== debian/changelog ===
twin (0.9.0-0ubuntu1) jammy; urgency=medium

  * Initial release (LP: 1947636)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 06 Oct 2021 18:33:47 -0700

=== debian/control ===
Source: twin
Section: misc
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               libx11-dev,
               libxft-dev,
               libncurses-dev,
               libltdl-dev,
               zlib1g-dev,
               libgpm-dev
Standards-Version: 4.5.1
Homepage: https://github.com/cosmos72/twin
Vcs-Browser: https://github.com/cosmos72/twin
Vcs-Git: https://github.com/cosmos72/twin
Rules-Requires-Root: no

Package: twin
Architecture: amd64 arm64 ppc64el s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Twin - a Textmode WINdow environment
 Twin is a windowing environment with mouse support, window manager,
 terminal emulator and networked clients, all inside a text display.
 It supports a variety of displays:
 .
 - plain text terminals (any termcap/ncurses compatible terminal,
   Linux console, twin's own terminal emulator);
 - X11, where it can be used as a multi-window xterm;
 - itself (you can display a twin on another twin);
 - twdisplay, a general network-transparent display client,
   used to attach/detach more displays on-the-fly.

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/twin-$1\.tar\.gz/ \
  https://github.com/cosmos72/twin/tags .*/v?(\d\S*)\.tar\.gz

## twin 0.9.0+git251119

=== debian/changelog ===
twin (0.9.0+git251119-0ubuntu1) resolute; urgency=medium

  * New git snapshot 0.9.0+251119
  * d/copyright: bump copyright dates
  * d/control: bump standards-version

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sun, 14 Dec 2025 09:00:15 -0800

## twin 1.0.0

=== debian/changelog ===
twin (1.0.0-0ubuntu1) resolute; urgency=medium

  * New upstream release 1.0.0

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sat, 03 Jan 2026 11:19:21 -0800

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libltdl-dev,
                zlib1g-dev,
                libgpm-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.7.2
 Homepage: https://github.com/cosmos72/twin
 Vcs-Browser: https://github.com/cosmos72/twin
 Vcs-Git: https://github.com/cosmos72/twin
